package business;
import query.Node;
import query.Constants;
import query.Parse;
import java.util.List;
import java.io.*;

public class DoWhileBodyPatch
{
    public static void annotateBodyEnd(Node p, String sPatch)
    {
        FindAll FA = new FindAll();
        List objListFor=FA.findAll(p,Constants.DOSTATEMENT,true);
        for(int iCount=0;iCount<objListFor.size();iCount++)
        {
        Node for_node=(Node)objListFor.get(iCount);

        switch(for_node.getChild(1).getChild(0).getType())
        {
            case Constants.EMPTYSTATEMENT :
                //for_node.getChild(1).getChild(0).getLast().setAnnotation("");
                for_node.getChild(1).getChild(0).getLast().setAnnotation("{\n",sPatch+"\n}");
                break;
            case Constants.STATEMENTEXPRESSION :
                case Constants.RETURNSTATEMENT :
                for_node.getChild(1).getFirst().setAnnotation("{\n",null);
                for_node.getChild(2).getFirst().setAnnotation(sPatch+"\n}",null);
                break;
            case Constants.BLOCK :
                for_node.getChild(1).getLast().setAnnotation(sPatch,null);
                break;
            case Constants.FORSTATEMENT:
                case Constants.IFSTATEMENT :
                case Constants.DOSTATEMENT :
                case Constants.WHILESTATEMENT :
                case Constants.SWITCHSTATEMENT :
                for_node.getChild(1).getFirst().setAnnotation("{\n",null);
                for_node.getChild(1).getLast().setAnnotation(null,sPatch+"\n}");
                break;
          }
        }
    }

    public static void annotateBodyBegin(Node p, String sPatch)
    {
        FindAll FA = new FindAll();
        List objListFor=FA.findAll(p,Constants.DOSTATEMENT,true);
        for(int iCount=0;iCount<objListFor.size();iCount++)
        {
        Node for_node=(Node)objListFor.get(iCount);


        switch(for_node.getChild(1).getChild(0).getType())
        {

            case Constants.EMPTYSTATEMENT :
               // for_node.getChild(1).getChild(0).getLast().setAnnotation("");
                for_node.getChild(1).getChild(0).getLast().setAnnotation("{\n"+sPatch,"\n}");
                break;
            case Constants.STATEMENTEXPRESSION :
                case Constants.RETURNSTATEMENT :
                for_node.getChild(1).getFirst().setAnnotation("{\n"+sPatch,null);
                for_node.getChild(1).getLast().setAnnotation(null,"\n}");
                break;
            case Constants.BLOCK :
                for_node.getChild(1).getFirst().setAnnotation(null,sPatch);
                break;
            case Constants.FORSTATEMENT:
                case Constants.IFSTATEMENT :
                case Constants.DOSTATEMENT :
                case Constants.WHILESTATEMENT :
                case Constants.SWITCHSTATEMENT :

                for_node.getChild(1).getFirst().setAnnotation("{\n"+sPatch,null);
                for_node.getChild(1).getLast().setAnnotation(null,"\n}");
                break;
          }
        }
    }

    public static void main(String[] args)
    {
        Parse p = new Parse(args[0]);
        if(p.getError() != null)
            System.err.println("Error in Parsing");

        // Parse p = new Parse(args[0]);

        else {
            Node root = p.getRoot();
            annotateBodyBegin(root,"test;\ntest;\n");
            try {
                FileDescriptor o = FileDescriptor.out;
                Writer w = new FileWriter(o);
                w = new BufferedWriter(w);
                root.print(p.getCommentList(), w);
                w.close();
            }
            catch (IOException e) {
                System.err.println(e);
            }
        }
    }

}
