package business;

import javax.sound.midi.*;
import javax.sound.midi.Synthesizer;
import javax.sound.midi.Instrument;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.MidiUnavailableException;
import java.util.Vector;

public class InstrumentLoader
{
    private Synthesizer objSynth = null;
    private Instrument objInstruments[] = null;
    private int MIDI_INSTRUMENTS_LENGTH=128;

    public InstrumentLoader()
    {
        try
        {
                objSynth = MidiSystem.getSynthesizer();
                objSynth.open();
        }
        catch (MidiUnavailableException mue)
        {
            mue.printStackTrace();
          System.out.println("MIDI EXCEPTION ");

        }

        objInstruments = objSynth.getAvailableInstruments();

    }


    public  Vector loadInstrumentNames()
    {
       Vector vInstrument = new Vector();

       for(int iLoop=0; iLoop < MIDI_INSTRUMENTS_LENGTH; iLoop++)
       {
            vInstrument.add(objInstruments[iLoop].getName().trim());

       }

       return vInstrument;
    }

}