package business;

import query.Constants;
import query.Node;
import query.Parse;
import java.util.List;
import java.util.Vector;
import java.io.*;


public class MethodReturnValueBasedPatch implements Constants
{
    private static long lID=1111;
    private static boolean bIfFlag=false;
    private static final int INT=0;
    private static final int STRING=1;

    public static String getPatch(boolean bFlag, String sValue, String sPatch, int iType)
    {
        switch(iType)
        {
            case INT:
                if(bFlag==false)
                {
                    bFlag=true;
                    return "\nif( value == "+sValue+" )\n{\n"+sPatch+"\n}";
                }
                else
                {
                    return "\nelse if( value == "+sValue+" )\n{\n"+sPatch+"\n}";
                }
            case STRING:
                if(bFlag==false)
                {
                    bFlag=true;
                    return "\nif( value.equals(\""+sValue+"\")==true )\n{\n"+sPatch+"\n}";
                }
                else
                {
                    return "\nelse if( value.equals(\""+sValue+"\")==true )\n{\n"+sPatch+"\n}";
                }
        }
        return "";
    }

    public static String getMethodBodyDefinition(String sMethodName, String sPatch, int iDataType)
    {
        String sMethod="";
        if(iDataType==STRING)
        {
            sMethod="public void "+sMethodName+"_VDAP(String value){\n"+sPatch+"\n}\n";
        }
        else if(iDataType==INT)
        {
            sMethod="public void "+sMethodName+"_VDAP(int value){\n"+sPatch+"\n}\n";
        }
        return sMethod;
    }

    public static String getMethodCall(String sMethodName, String sVariable)
    {
        return sMethodName+"_VDAP("+sVariable+");\n";
    }

    public static String generateVariableID()
    {
       // return "__JLISTEN_DECLARATION";
        return "__JLISTEN__"+(++lID);
    }

    public static String getVariableDecl(String sVariableID, String sVariableType, String sAssignment)
    {
        return sVariableType+" "+sVariableID+" = "+sAssignment+" ;\n";
    }



    public static void annotateBodyEnd(Node objNode ,Vector vPatches, String sMethod, Vector vParams, Vector vValues,
                                       int iDataType, String sPatchMethodName)
    {
       FindAll objFA= new FindAll();
        System.out.println("METH:  "+sMethod+ " ; param= "+vParams.size());

        List objList = objFA.findallinclusive(objNode, Constants.METHODDECLARATION, true);

        if(objList.size() > 0)
        {
            for(int i=0;i<objList.size(); i++)
            {

               List objLBrace= objFA.findallinclusive(((Node)objList.get(i)),Constants.BLOCK, true);
                Node objTemp = (Node)objList.get(i);

                List objResultType= objFA.findallinclusive(objTemp, Constants.RESULTTYPE, true);
                List objMethodDeclaration=objFA.findallinclusive(objTemp, Constants.METHODDECLARATION, true);
                Node nodeMethodDeclaration=(Node)objMethodDeclaration.get(0);
                List objMethDecl = objFA.findallinclusive(objTemp, Constants.METHODDECLARATOR, true);
                String sMethodName=((Node)objMethDecl.get(0)).getChild(0).getString();

                if(sMethod.equals(sMethodName))
                {

                    List objFormalParameters=objFA.findallinclusive(((Node)objMethDecl.get(0)), Constants.FORMALPARAMETERS, true);

                    List objParameters=objFA.findallinclusive(((Node)objFormalParameters.get(0)),Constants.FORMALPARAMETER, true);



                    if(objParameters.size() > 0)
                    {
                        Vector vParameters = new Vector();
                        for(int j=0;j<objParameters.size();j++)
                        {
                            String sTypeName = ((Node)objParameters.get(j)).getFirst().getString();
                            vParameters.add(sTypeName);

                        }

                        if((vParams!=null) && (vParameters.size() != vParams.size()))
                            continue;
                            //return;
                        else
                        {
                            if(vParams!=null)
                            {
                                int flag=0;
                                for(int j=0; j< vParameters.size(); j++)
                                {
                                    if(!vParameters.get(j).toString().equalsIgnoreCase(vParams.get(j).toString()))
                                    {
                                     flag=1;
                                     break;
                                    }
                                }
                                if(flag == 1)
                                    continue;
                                   //return;
                                // ((Node)objLBrace.get(0)).getFirst().setAnnotation(null,vPatch.get(0).toString());
                            }
                        }
                    }else{
                          if(((vParams != null)&&(vParams.size()==1)&&(vParams.get(0).toString().equalsIgnoreCase("void")==false)))
                                {
                                     continue;
                                }
                        }
                    boolean bIsReturn=false;

                    //List objMethodDefinition =objFA.findallinclusive(objNode,Consta);
                    List objStatements= objFA.findallinclusive(objTemp,Constants.STATEMENT,true);

                    if(objStatements.size() > 0)
                    {

                        StringBuffer sbPatchValues=new StringBuffer();
                        for(int iStatLoop=0; iStatLoop <objStatements.size(); iStatLoop++)
                        {
                            Node objReturn = ((Node)objStatements.get(iStatLoop)).getChildType(Constants.RETURNSTATEMENT);
                            if(objReturn!= null)
                            {
                                bIsReturn=true;
                                StringBuffer sbFunctionPatches= new StringBuffer();
                                objReturn.getAllLeaves(objReturn.getChild(1),sbFunctionPatches);
                                String sVariable=generateVariableID();
                                objReturn.getChild(1).clearParseTreeContents(objReturn.getChild(1));
                                objReturn.getChild(1).getFirst().setAnnotation(sVariable);

                                String sDeclaration=getVariableDecl(sVariable,((Node)objResultType.get(0)).getFirst().getString(), sbFunctionPatches.toString());
                                objReturn.getChild(0).setAnnotation("\n{\n"+sDeclaration+"\n",null);

                                //objReturn.getChild(0).setAnnotation(getPatch(false,sVariable, vValues.get(0).toString(),vPatches.get(0).toString(),iDataType),null);


                                  // sbPatchValues.append(getPatch(true, vValues.get(iInnerLoop).toString(),vPatches.get(iInnerLoop).toString(),iDataType));
                                   objReturn.getChild(0).setAnnotation(getMethodCall(sPatchMethodName,sVariable),null);


                                objReturn.getChild(0).setAnnotation("",null);
                                objReturn.getChild(2).setAnnotation(null,"\n}\n");
                            }
                        }
                        for(int iInnerLoop=0; iInnerLoop < vValues.size();iInnerLoop++)
                                {
                                   sbPatchValues.append(getPatch(false, vValues.get(iInnerLoop).toString(),vPatches.get(iInnerLoop).toString(),iDataType));
                                    //objReturn.getChild(0).setAnnotation(getPatch(true,sVariable, vValues.get(iInnerLoop).toString(),vPatches.get(iInnerLoop).toString(),iDataType),null);
                                }
                        nodeMethodDeclaration.getFirst().setAnnotation(getMethodBodyDefinition(sPatchMethodName,
                                            sbPatchValues.toString(), iDataType),null);

                    }
                }
            }
        }

     }
public static void main(String[] args)
    {
        Parse p = new Parse(args[0]);
        if(p.getError() != null)
            System.err.println("Error in Parsing");

        else {
            Node root = p.getRoot();
            int iType=STRING;
            Vector v= new Vector();

            v.add("System.out.println(\"1: *******PATCHED FUNCTION END******\");");
            v.add("System.out.println(\"2: *******PATCHED FUNCTION END******\");");
            v.add("System.out.println(\"3: *******PATCHED FUNCTION END******\");");
            v.add("System.out.println(\"4: *******PATCHED FUNCTION END******\");");

            Vector value= new Vector();
            value.add("1");
            value.add("2");
            value.add("3");
            value.add("4");

            Vector param= new Vector();
            param.add("string");

            annotateBodyEnd(root,v, "test",param,value,iType,"TEST");
           // annotate(root,v,"fibonacci");


            try {
                FileDescriptor o = FileDescriptor.out;
                Writer w = new FileWriter(o);
                w = new BufferedWriter(w);
                root.print(p.getCommentList(), w);
                w.close();
            }
            catch (IOException e) {
                System.err.println(e);
            }

        }
    }


}