package business;

import java.util.Vector;


public class SoundCallsLibrary implements SoundCallsConstants
{
    public SoundCallsLibrary()
    {

    }


    public String getImportStatementPatches(String sJavaFileName)
    {
        // return sPackageName+sJavaFileName+";\n"+sImportStatements;
        return sImportStatements;
    }


    public String getConstructorPatch(String sProgramName)
    {
        return sPatchHeader+sConnection+"\n{EventInfo objEI = new EventInfo(\"START\",false,null,null);\n"+sTryStatement+sSoundCallMethod+"(\""+sProgramName+"\", objEI);"+sCatchStatement;
    }

    public String getFinalizePatch(String sProgramName)
    {
        return sPatchHeader+"\n{EventInfo objEI = new EventInfo(\"END\",false,null,null);"+sTryStatement+sSoundCallMethod+"(\""+sProgramName+"\", objEI);"+sCatchStatement;
    }

    public Vector getSoundCallPatches(String sProgramName, Vector vLSLTokens)
    {
        Vector vSoundCallPatches = new Vector();

        LSLTokens objLSL = null;
        String sPackageName =null;
        String sClassName =  null;
        String sMethodName = null;
        String sKeyword = null;

        String sIdentifer = null;
        String sDtrack ="null";

        StringBuffer sbEventName= null;
        StringBuffer sbPatch= null;

        for(int iLoop = 0; iLoop < vLSLTokens.size(); iLoop++)
        {
            sbEventName=null;
            sbPatch=null;

            sbEventName= new StringBuffer();
            sbPatch= new StringBuffer();

            objLSL = (LSLTokens)vLSLTokens.get(iLoop);

            if((sPackageName=objLSL.getPackageName()) != null)
            {
                sbEventName.append(sPackageName);
                sbEventName.append("_");
            }

            if((sClassName=objLSL.getClassName()) != null)
            {
                sbEventName.append(sClassName);
                sbEventName.append("_");
            }

            if((sMethodName=objLSL.getMethodName()) != null)
            {
                sbEventName.append(sMethodName);
                sbEventName.append("_");
            }

            if((sKeyword=objLSL.getKeyword()) != null)
            {
                if(sKeyword.equalsIgnoreCase("dtrack"))
                {
                    sDtrack = "new Integer("+objLSL.getIdentifier()+")";
                }else
                {
                    sDtrack ="null";
                }
                sbEventName.append(sKeyword);
                sbEventName.append("_");
                if(sKeyword.equalsIgnoreCase("switch_case_begin") && (objLSL.getParameters()!=null)&&(objLSL.getParameters().size()==1))
                {
                    sbEventName.append(objLSL.getParameters().get(0).toString());
                    sbEventName.append("_");
                }else if(objLSL.getParameters()!=null)
                {
                    sbEventName.append("param_");
                    for(int i=0;i<objLSL.getParameters().size();i++)
                    {
                        sbEventName.append(objLSL.getParameters().get(i).toString());
                        sbEventName.append("_");
                    }
                }

            }

            if(objLSL.getDataType()>=0)
            {
                sbEventName.append(objLSL.getDataType());
                sbEventName.append("_");
            }
            if((sIdentifer = objLSL.getIdentifier()) != null)
            {
                sbEventName.append(sIdentifer);
                sbEventName.append("_");
            }

            int iLastIndex = sbEventName.toString().lastIndexOf('_');

            if(iLastIndex !=  -1)
            {
                sbEventName.deleteCharAt(iLastIndex);
            }
            if(objLSL.getMethodReturnValues()!=null)
                       {
                System.out.println("--------");
                           Vector vActivity = new Vector();
                           for(int i=0;i<objLSL.getMethodReturnValues().size();i++)
                           {
                               StringBuffer sbNewEventName=new StringBuffer();
                               StringBuffer sbTemp = new StringBuffer(sbPatch.toString());
                               sbNewEventName.append(sbEventName);
                               sbNewEventName.append(objLSL.getMethodReturnValues().get(i));
                               sbTemp.append(sPatchHeader+"\n{"+sEventSendMethod+" objEI = new "+sEventSendMethod+"( \""+sbNewEventName.toString()+"\", false, \"\", null);\n");
                               sbTemp.append(sTryStatement+sSoundCallMethod+"( \""+sProgramName+"\", objEI ); "+sCatchStatement);
                               vActivity.add(sbTemp.toString());
                               System.out.println("--------"+objLSL.getMethodReturnValues().get(i));
                           }
                           /*sbTemp.append(sPatchHeader+"\n{"+sEventSendMethod+" objEI = new "+sEventSendMethod+"( \""+sbEventName.toString()+"\", true, \"END\", null);\n");
                           sbTemp.append(sTryStatement+sSoundCallMethod+"( \""+sProgramName+"\", objEI ); "+sCatchStatement);
                           vActivity.add(sbTemp.toString());

                           vSoundCallPatches.add(vActivity);  // adding patches
                           */
                    vSoundCallPatches.add(vActivity);  // adding patches
                       }

            //System.out.println("PATCH sound call event name="+sbEventName);
           else if(objLSL.isActivity() != false)
            {
                Vector vActivity = new Vector();
                StringBuffer sbTemp = new StringBuffer(sbPatch.toString());

                sbPatch.append(sPatchHeader+"\n{"+sEventSendMethod+" objEI = new "+sEventSendMethod+"( \""+sbEventName.toString()+"\", true, \"START\", null);\n");
                sbPatch.append(sTryStatement+sSoundCallMethod+"( \""+sProgramName+"\", objEI ); "+sCatchStatement);
                vActivity.add(sbPatch.toString());
                sbTemp.append(sPatchHeader+"\n{"+sEventSendMethod+" objEI = new "+sEventSendMethod+"( \""+sbEventName.toString()+"\", true, \"END\", null);\n");
                sbTemp.append(sTryStatement+sSoundCallMethod+"( \""+sProgramName+"\", objEI ); "+sCatchStatement);
                vActivity.add(sbTemp.toString());

                vSoundCallPatches.add(vActivity);  // adding patches
            }
            else
            {
                sbPatch.append(sPatchHeader+"\n{"+sEventSendMethod+" objEI = new "+sEventSendMethod+"( \""+sbEventName.toString()+"\", false, null, "+sDtrack+");\n");
                sbPatch.append(sTryStatement+sSoundCallMethod+"( \""+sProgramName+"\", objEI ); "+sCatchStatement);

                vSoundCallPatches.add(sbPatch.toString()); // adding patches
            }
        }
        System.out.println("OUT PATCHES!!!!!!!!!!!!!!!!");
        return vSoundCallPatches;
    }


}