package business;
import query.Node;
import query.Constants;
import query.Parse;

import java.util.List;

public class TestConstructorPatch
{

    public boolean doesContainMain(Node node)
    {
        // Checks whether this compilation unit contains main
        List LMethodDeclaration;
        FindAll TFA = new FindAll();
        LMethodDeclaration = TFA.findAll(node,Constants.METHODDECLARATION,true);
        for(int iLoop = 0; iLoop < LMethodDeclaration.size();iLoop ++)
        {
            Node nMethodDeclarator;
            nMethodDeclarator = ((Node)(LMethodDeclaration.get(iLoop))).find(Constants.METHODDECLARATOR);

            if(nMethodDeclarator.getFirst().getString().equalsIgnoreCase("main"))
            {
                System.out.println("Returning True");
                return true;
            }
        }
        return false;
    }
    public Node retNodeContainingFinalize(Node objNode)
    {
        List LMethodDeclaration;
        FindAll TFA = new FindAll();
        LMethodDeclaration = TFA.findAll(objNode,Constants.METHODDECLARATION,true);
        for(int iLoop = 0;iLoop < LMethodDeclaration.size();iLoop ++)
        {
            Node nMethodDeclarator;
            nMethodDeclarator = ((Node)(LMethodDeclaration.get(iLoop))).find(Constants.METHODDECLARATOR);
            if(nMethodDeclarator.getFirst().getString().equalsIgnoreCase("finalize"))
            {
                return ((Node)(LMethodDeclaration.get(iLoop)));
            }
        }
        return null;

    }
    public Node getClassWithMain(Node objroot)
    {
        List LcompUnitList;
        FindAll TFA = new FindAll();
        boolean bContainsMain;
        Node nMainNode=null;
        int iflag = 0;
        LcompUnitList = TFA.findallinclusive(objroot,Constants.CLASSDECLARATION,true);
        System.out.println("Compilation Units-----"+LcompUnitList.size());
        for(int iLoop = 0;iLoop < LcompUnitList.size();iLoop ++)
        {
            bContainsMain = doesContainMain( ( (Node)(LcompUnitList.get(iLoop)) ) );
            if(bContainsMain == true)
            {
                System.out.println("Inside bContains Main");
                nMainNode = ( (Node)(LcompUnitList.get(iLoop)) );
                iflag = 1;
                break;
            }
        }
        if(iflag == 0)
        {
            System.out.println("No Main found in any classes");
            return null;
        }
        else
        {
            System.out.println(nMainNode.getType());
            return nMainNode;
        }
    }
    public List getConstructorList(Node objnode)
    {
        List Lconstructors;
        FindAll TFA = new FindAll();
        System.out.println(objnode.getType());
        Lconstructors = TFA.findAll(objnode,Constants.CONSTRUCTORDECLARATION,true);
        return Lconstructors;
    }
    public String getClassName(Node objNode)
    {
        Node objUMCD;
        StringBuffer sb = new StringBuffer();
        objUMCD = objNode.find(Constants.UNMODIFIEDCLASSDECLARATION,true);
        String strClass = objUMCD.find(Constants.CLASS).getString();
        String strClassName=objUMCD.find(Constants.IDENTIFIER).getString();
//        sb.append(strClass);
//        sb.append(" ");
        sb.append(strClassName);
        sb.append(" ()");

        return sb.toString();
    }

    public void patchFinalize(Node objroot,String sFinalizePatch)
    {
        Node nMainNode;
        Node nFinalizenode;
        nMainNode = getClassWithMain(objroot);
        nFinalizenode = retNodeContainingFinalize(nMainNode);
        if(nFinalizenode != null)
        {
            nFinalizenode.getChild(nFinalizenode.getNumChildren()-1).getFirst().setAnnotation(null,"{FINALIZE RMI}");
        }
        else
        {
            Node objClassBody=nMainNode.find(Constants.CLASSBODY,true);
            Node objClassBodyLbrace = objClassBody.find(Constants.LBRACE);
            //StringBuffer sb = new StringBuffer(objClassBodyLbrace.getAnnotation().getRight());
            //sb.append("public finalize(){FINALIZE RMI}");
            objClassBodyLbrace.setAnnotation(null," public void finalize() "+"{"+sFinalizePatch+"}");
        }

    }
    public boolean patchEndMain(Node objRoot,String sEndMainPatch)
    {
        List lMethodDecl;
        lMethodDecl = DecoratorHandler.getMethodWithName(objRoot,"main");
        if(lMethodDecl==null)
        {
            return false;
        }
        for(int iIndex = 0;iIndex < lMethodDecl.size();iIndex ++)
        {
            Node objMethodDecln = (Node)lMethodDecl.get(iIndex);
            if(objMethodDecln != null)
            {
              int  inum_of_children = objMethodDecln.getNumChildren();
              objMethodDecln.getChild(inum_of_children-1).getLast().setAnnotation(sEndMainPatch,null);
            }
        }
        return true;
    }
    public void patchConstructor(Node objroot,String sConstructorPatch)
    {
        Node nMainNode;
        List Lconstructors;
        nMainNode = this.getClassWithMain(objroot);
        if(nMainNode == null)
        {
            System.err.println("Error in nMainNode");
        }
        Lconstructors = getConstructorList(nMainNode);
        if(Lconstructors.size() > 0)
        {
            for(int iLoop = 0;iLoop < Lconstructors.size();iLoop ++)
            {
                Node nConstructorLbrace;
                nConstructorLbrace = ( (Node)(Lconstructors.get(iLoop))).find(Constants.LBRACE);
                nConstructorLbrace.setAnnotation(null,sConstructorPatch);
            }
        }
        else
        {
            String strClassName = getClassName(nMainNode);
            Node objClassBody = nMainNode.find(Constants.CLASSBODY,true);
            StringBuffer sb = new StringBuffer(strClassName);
            sb.append("{"+sConstructorPatch+"}");
            Node objClassBodyLbrace = objClassBody.find(Constants.LBRACE);
            objClassBodyLbrace.setAnnotation(null,sb.toString());
        }

    }
    public static void main(String[] args)
    {
        Parse objParse = new Parse(args[0]);
        TestRecMethod TRM = new TestRecMethod();
        TestConstructorPatch TCP = new TestConstructorPatch();
        if(objParse.getError() != null)
        {
            System.err.println("Error in Parsing");
        }
        else
        {
            System.out.println(objParse.getRoot().getType());
            TCP.patchConstructor(objParse.getRoot(),"{Start Rmi Constructor patch}");
            TCP.patchFinalize(objParse.getRoot(),"{Stop rmi Finalize patch}");
            TRM.fprintDecoratedCode(objParse);

        }
    }
}