// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 3/8/2003 4:08:57 PM
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   Node.java

package query;

import java.io.PrintStream;
import java.io.Writer;
import java.util.Vector;

// Referenced classes of package query:
//            InvalidAnnotationException, Annotation, CommentStream, Constants, 
//            Token, NodeStack, CommentList

public final class Node
    implements Constants
{

    Node(int i, Token token)
    {
        info1 = token.image;
        info2 = token.beginColumn << 8 | i;
        ln = token.beginLine;
    }

    Node(int i, NodeStack nodestack)
    {
        info1 = nodestack.get();
        int j = 0;
        if(getNumChildren() >= 1)
        {
            ln = getChild(0).getLn();
            j = getChild(0).getCol();
        }
        info2 = j << 8 | i;
    }

    public boolean isTerm()
    {
        return getType() <= 127;
    }

    public boolean isNonTerm()
    {
        return getType() > 127;
    }

    public synchronized void setAnnotation(String s, String s1)
        throws InvalidAnnotationException
    {
        if(!isTerm())
            throw new InvalidAnnotationException("non-terminal");
        if(info1 instanceof Annotation)
            ((Annotation)info1).append(s, s1);
        else
            info1 = new Annotation(s, (String)info1, s1);
    }

    public synchronized void setAnnotation(String sLeafValue  )
        throws InvalidAnnotationException
    {
        if(!isTerm())
            throw new InvalidAnnotationException("non-terminal");
        if(info1 instanceof Annotation)
            ((Annotation)info1).setString(sLeafValue);
        else
            info1 = new Annotation("", sLeafValue, "");
    }

    public Annotation getAnnotation()
    {
        if(info1 instanceof Annotation)
            return (Annotation)info1;
        else
            return null;
    }

    public int getType()
    {
        return info2 & 0xff;
    }

    public int getNumChildren()
    {
        if(info1 instanceof Node)
            return 1;
        if(info1 instanceof Node[])
            return ((Node[])info1).length;
        else
            return 0;
    }

    public Node getChild(int i)
    {
        if((info1 instanceof Node) && i == 0)
            return (Node)info1;
        if(info1 instanceof Node[])
            return ((Node[])info1)[i];
        else
            return null;
    }

    public String getString()
    {
        if(info1 instanceof String)
            return (String)info1;
        if(info1 instanceof Annotation)
            return ((Annotation)info1).getString();
        else
            return null;
    }

    public int getLn()
    {
        return ln;
    }

    public int getCol()
    {
        return info2 >>> 8;
    }

    public Node getFirst()
    {
        Node node;
        for(node = this; node.isNonTerm(); node = node.getChild(0));
        return node;
    }

    public void getAllLeaves(Node objNode, StringBuffer sbContents)
    {
        for (int i=0; i< objNode.getNumChildren();i++)
        {
            Node objChild = objNode.getChild(i);
            if(objChild.isNonTerm())
            {
                //System.out.println("-------TYPE  "+objChild.getType());
                getAllLeaves(objChild, sbContents);
            }
            else
            {
                sbContents.append(objChild.getString());
                //System.out.println("-------"+sbContents.toString());
            }
        }
    }
    public  void clearParseTreeContents(Node objNode)
    {
        for (int i=0; i< objNode.getNumChildren();i++)
        {
            Node objChild = objNode.getChild(i);
            if(objChild.isNonTerm())
            {
                clearParseTreeContents(objChild);
            }
            else
            {
                objChild.setAnnotation("");
            }
        }
    }
    public boolean isChild(Node objParent, Node objChild)
    {

        for (int i=0; i< objParent.getNumChildren();i++)
        {
            Node objNode = objParent.getChild(i);
            if(objNode.equals(objChild))
                           return true;
            if(objNode.isNonTerm())
            {
                if(isChild(objNode, objChild)==true) return true;
            }
        }
        return false;
    }
   public void changeParseTreeValues(Node objNode, String sAssignment)
    {

//       System.out.println("1stchild----"+objNode.getChild(0).getString());
       objNode.getChild(0).setAnnotation(sAssignment);
//        System.out.println("C___-"+objNode.getNumChildren());
        for(int i=1; i< objNode.getNumChildren(); i++)
        {
//            System.out.println(i+"th child----"+objNode.getChild(i).getString());
            objNode.getChild(i).setAnnotation("");
        }
    }

    public Node getChildType(int type)
    {
        for(int i=0;i < this.getNumChildren(); i++)
        {
            if(type==this.getChild(i).getType())
            {
                return  this.getChild(i);
            }
        }
        return null;
    }



    public Node getLast()
    {
        Node node;
        for(node = this; node.isNonTerm(); node = node.getChild(node.getNumChildren() - 1));
        return node;
    }

    public Node find(int i)
    {
        return find(i, false);
    }

    public Node find(int i, boolean flag)
    {
        if(getType() == i)
            return this;
        int j = getNumChildren();
        if(j == 0)
            return null;
        if(!flag)
        {
            for(int k = 0; k < j; k++)
                if(getChild(k).getType() == i)
                    return getChild(k);

        } else
        {
            for(int l = 0; l < j; l++)
            {
                Node node = getChild(l).find(i, true);
                if(node != null)
                    return node;
            }

        }
        return null;
    }

    public boolean equals(Node node)
    {
        if(node == null)
            return false;
        if(getType() != node.getType())
            return false;
        if(getLn() != node.getLn() || getCol() != node.getCol())
            return false;
        if(isTerm())
            if(!node.isTerm())
                return false;
            else
                return getString().equals(node.getString());
        int i = getNumChildren();
        if(i != node.getNumChildren())
            return false;
        for(int j = 0; j < i; j++)
            if(!getChild(j).equals(node.getChild(j)))
                return false;

        return true;
    }

    public void print(CommentList commentlist, Writer writer)
    {
        CommentStream commentstream = new CommentStream(commentlist);
        print2(commentstream, writer);
        commentstream.dumpRest(writer);
    }

    private void print2(CommentStream commentstream, Writer writer)
    {
        if(isTerm())
        {
            commentstream.dumpUpTo(getLn(), getCol(), writer);
            Annotation annotation = getAnnotation();
            try
            {
                if(annotation == null)
                {
                    writer.write(getString());
                } else
                {
                    String s = null;
                    if((s = annotation.getLeft()) != null)
                        writer.write(s);
                    writer.write(annotation.getString());
                    if((s = annotation.getRight()) != null)
                        writer.write(s);
                }
            }
            catch(Throwable throwable)
            {
                System.err.println(throwable);
                System.exit(1);
            }
        } else
        {
            int i = getNumChildren();
            for(int j = 0; j < i; j++)
                getChild(j).print2(commentstream, writer);

        }
    }

    public static String copyright = "Copyright (C) 1998 Glen McCluskey & Associates LLC.  All Rights Reserved.";
    private int ln;
    private Object info1;
    private int info2;
    static int x37;

}